<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViaPointUpdate ArrayType
 * @subpackage Arrays
 */
class ArrayOfViaPointUpdate extends AbstractStructArrayBase
{
    /**
     * The ViaPointUpdate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViaPointUpdate[]
     */
    public $ViaPointUpdate;
    /**
     * Constructor method for ArrayOfViaPointUpdate
     * @uses ArrayOfViaPointUpdate::setViaPointUpdate()
     * @param \StructType\ViaPointUpdate[] $viaPointUpdate
     */
    public function __construct(array $viaPointUpdate = array())
    {
        $this
            ->setViaPointUpdate($viaPointUpdate);
    }
    /**
     * Get ViaPointUpdate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViaPointUpdate[]|null
     */
    public function getViaPointUpdate()
    {
        return isset($this->ViaPointUpdate) ? $this->ViaPointUpdate : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViaPointUpdate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViaPointUpdate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViaPointUpdateForArrayConstraintsFromSetViaPointUpdate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViaPointUpdateViaPointUpdateItem) {
            // validation for constraint: itemType
            if (!$arrayOfViaPointUpdateViaPointUpdateItem instanceof \StructType\ViaPointUpdate) {
                $invalidValues[] = is_object($arrayOfViaPointUpdateViaPointUpdateItem) ? get_class($arrayOfViaPointUpdateViaPointUpdateItem) : sprintf('%s(%s)', gettype($arrayOfViaPointUpdateViaPointUpdateItem), var_export($arrayOfViaPointUpdateViaPointUpdateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViaPointUpdate property can only contain items of type \StructType\ViaPointUpdate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViaPointUpdate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViaPointUpdate[] $viaPointUpdate
     * @return \ArrayType\ArrayOfViaPointUpdate
     */
    public function setViaPointUpdate(array $viaPointUpdate = array())
    {
        // validation for constraint: array
        if ('' !== ($viaPointUpdateArrayErrorMessage = self::validateViaPointUpdateForArrayConstraintsFromSetViaPointUpdate($viaPointUpdate))) {
            throw new \InvalidArgumentException($viaPointUpdateArrayErrorMessage, __LINE__);
        }
        if (is_null($viaPointUpdate) || (is_array($viaPointUpdate) && empty($viaPointUpdate))) {
            unset($this->ViaPointUpdate);
        } else {
            $this->ViaPointUpdate = $viaPointUpdate;
        }
        return $this;
    }
    /**
     * Add item to ViaPointUpdate value
     * @throws \InvalidArgumentException
     * @param \StructType\ViaPointUpdate $item
     * @return \ArrayType\ArrayOfViaPointUpdate
     */
    public function addToViaPointUpdate(\StructType\ViaPointUpdate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViaPointUpdate) {
            throw new \InvalidArgumentException(sprintf('The ViaPointUpdate property can only contain items of type \StructType\ViaPointUpdate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViaPointUpdate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViaPointUpdate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViaPointUpdate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViaPointUpdate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViaPointUpdate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViaPointUpdate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViaPointUpdate
     */
    public function getAttributeName()
    {
        return 'ViaPointUpdate';
    }
}
